from Products.CMFCore.DirectoryView import createDirectoryView
from Products.CMFCore.utils import getToolByName

from Products.PloneS5.config import skin_dirs, skin_names, actions, action_icons

def install(self):
    """ Install this product """
    out = []
    typesTool = getToolByName(self, 'portal_types')
    skinsTool = getToolByName(self, 'portal_skins')
        
    # add in the directory view pointing to our skin
    for name, location in zip(skin_names, skin_dirs):
        if name not in skinsTool.objectIds():
            createDirectoryView(skinsTool, location, name)
            out.append('Added "%s" directory view to portal_skins' % name)

    # add in the layer to all our skins    
    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = [ p.strip() for p in path.split(',') ]
        for name, location in zip(skin_names, skin_dirs):
            if name not in path:
                path.insert(path.index('custom')+1, name)

                p = ", ".join(path)
                skinsTool.addSkinSelection(skin, p)
                out.append('Added "%s" to "%s" skins' % (name, skin))
            else:
                out.append('Skipping "%s" skin' % skin)

    action_tool = getToolByName(self, 'portal_actions')
    action_ids = [ a.getId() for a in action_tool.listActions() ]
    for action in actions:
        if action['id'] not in action_ids:
            action_tool.addAction(**action)
            out.append('Installed action %s' % (action['name'],))
        else:
            out.append('Action %s was already installed' % (action['name'],))

    action_icons_tool = getToolByName(self, 'portal_actionicons')
    for category, config in action_icons.items():
        for icon_id, info in config.items():
            if action_icons_tool.queryActionIcon(category, icon_id, None) is None:
                action_icons_tool.addActionIcon(category, icon_id,
                                 info[0], info[1])
                out.append('Installed action icon '
                               'for %s.' % info[1])
            else:
                out.append('Action Icon for %s '
                               'was already Installed.'
                               % info[1])


    return "\n".join(out)
